require 'phr_logging'

module Faraday
  module ClientErrorHandling
    class Parser < Faraday::Response::Middleware
      def on_complete(env)
        if env[:body].size == 0
          env[:body] = {
            data: {},
            errors: {},
            metadata: {}
          }
        else
          json = MultiJson.load(env[:body], symbolize_keys: true)

          errors = json.delete(:errors) || {}

          if !errors.empty?
            PhrLogging.logger.warn "SERVICE ERRORS: #{errors}"
          end

          metadata = json.delete(:metadata) || {}
          env[:body] = {
            data: json,
            errors: errors,
            metadata: metadata
          }
        end
      end
    end
  end
end
